#include "vs1103.h"

#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
#define SPI_MISO  4
#define SPI_xCS2  8
#define SPI_MOSI  1 /* DREQ */

//#define USEDELAY
#ifdef USEDELAY
	.sect code,SpiDelay2
	.export _SpiDelay2
_SpiDelay2:
	mv a1,i5
	ldc 20,a1	//Need long enough, especially with linear WAV
$1:	add a1,ones,a1
	nop
	jzc $1
	nop
	jr
	mv i5,a1
#endif

	.sect code,SpiSendReceiveSpi
	.export _SpiSendReceiveSpi
_SpiSendReceiveSpi:
// auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx i0,(i6)	; sty d1,(i6)
	mv a1,i0	//ldc 16,i0
	ldc SER_DREQ,i7
$1:
	lsl a0,a1
	lslc null,a1	; mv lr0,d1
#ifdef USEDELAY
	call _SpiDelay2
	stx a1,(i7)+(GPIO_ODATA-SER_DREQ) ; ldy (i0)-1,null
	// first bit to send
	nop
	nop
#else
	stx a1,(i7)+(GPIO_ODATA-SER_DREQ) ; ldy (i0)-1,null
	// first bit to send
	nop
	nop
#endif

	ldc SPI_CLK|SPI_xCS2,a1
#ifdef USEDELAY
	call _SpiDelay2
#endif
	stx a1,(i7)+(GPIO_IDATA-GPIO_ODATA)	// clk up

	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	// read data

#ifdef USEDELAY
	lsr a1,a1
	lsr a1,a1
	lsr a1,a1
	lslc a0,a0 ; mv i0,a1	// collect input data, shift output data
	add a1,null,a1	; mv d1,lr0
#else
	ldc -3,d1
	ashl a1,d1,a1
	lslc a0,a0 ; mv i0,a1	// collect input data, shift output data
	add a1,null,a1
#endif
	ldc SPI_xCS2,a1
	jzc $1
	stx a1,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down

	jr
	ldx (i6)-1,i0	; ldy (i6),d1


	.end
