/*
X:	_streamBuffer 0x0..0x1ff
	_rxRtMidi 0x200..203
	_imabss 0x20d..0x20f
	_rxBuf 0x210..0x21f
	bassOn,trebleOn,streamMode,..	0x222..
	pcm_sample,pcm_point 0x232..
	generalbss applAddr 0x273..
	ai, outBuf 0x27f...
	bassCompandMaxGain 0x2c1
	_wav,.. 0x2c2..
	_er 0x2eb..

	mixerbufs 0x300..
	_codecMidi 0x400..0x17ff
	_userArea 0x1800..0x187f
	_stack 0x1880..0x19ff
	_parametric_x 0x1a00..0x1a3f
	_mixer.. 0x1a40..

y:	audioBuffer 0x0..0x7ff
	reverbDelays 0x800..0x13ff
	sci_buffer/imaOutBuf 0x1400..17ff
	_userArea 0x1800..0x187f
	_stack 0x1880..0x19ff
	 modbuf 0x1a00..0x1a3f
	 trebleFilt 0x1a40..
	 bss_y 0x1a52..

*/

#include <h1103/hardware.h>
#include <module.h>


	.sect code,reset
	.org 0x30

//	ldc INT_GLOB_DIS,i7
//	stx i7,(i7)

	ldc _myintvectors,i0
	ldc 0x20,i1	// DAC 0x20
	ldi (i0)+1,a
	sti a,(i1)+3
	ldi (i0)+1,a	// MODU 0x23
	sti a,(i1)

	j _MyReset+1
	ldc 1,a1	// perform full init
	.import _MyMain
	.export _MyReset
_MyReset:
	ldc 0,a1	// perform partial init
	j _MyMain
	ldc _mystack,i6


	.sect data_x,mylargebuf_x
	.palign MY_LARGE_BUF_SIZE
	.export _myLargeBuf
_myLargeBuf:
	.bss MY_LARGE_BUF_SIZE

	.sect data_y,mylargebuf_y
	.palign MY_LARGE_BUF_SIZE
	.bss MY_LARGE_BUF_SIZE

	.sect data_x,mystack_x
	.org 0x1000
_mystack:
	.bss 0x80

	.sect data_y,mystack_y
	.org 0x1000
	.bss 0x80

	.sect data_y,myModBuffer
	.palign MY_MOD_BUF_SIZE
	.export _myModBuf
_myModBuf:
	.bss MY_MOD_BUF_SIZE




	.sect code,myintvectors
_myintvectors:
	jmpi _MyDacInt,(i6)+1	// DAC	0x20
	jmpi _MyModuInt,(i6)+1	// MODU 0x23

	/* Mono signal DAC interrupt, pointers in X memory */
	.sect code,MyDacInt
	.export _MyDacInt
_MyDacInt:
	sty i7,(i6)+1
	stx I3,(I6)+1	; sty I2,(I6)
	stx D0,(I6)+1	; sty I1,(i6)

	.import _myLargeRdPointer
	ldc _myLargeRdPointer,I7
	ldc 0x8000+MY_LARGE_BUF_SIZE-1,i2

	ldx (I7),I3; sty mr0,(i6)
	ldc MR_SAT,mr0
	ldx (I3)*,D0
	ldc DAC_LEFT,I1
//	add d0,d0,d0
#if 1
	//Inverted mode
	sub null,d0,d0;	stx d0,(I1)+1
#else
	stx d0,(I1)+1
#endif
	stx d0,(i1)
	stx i3,(i7); ldy (i6)-1,mr0

	ldx (I6)-1,D0	; ldy (I6),I1
	ldx (i6)-1,I3	; ldy (I6),I2

	ldc INT_GLOB_ENA,i7
	reti
	stx i7,(i7)	; ldy (i6)-1,i7



	.sect code,MyModuInt
	.export _MyModuInt
	.import _moduOffset
_MyModuInt:
	// 29+2 cycles
	sty i7,(i6)+1
	stx I3,(I6)+1	; sty I2,(I6)
	stx D0,(I6)+1	; sty I1,(i6)
	stx A2,(I6)+1	; sty I4,(i6)
	stx A0,(I6)+1	; sty A1,(i6)
	add null,p,a	; stx MR0,(I6)+1 // Must be before add null,p,a !!:-)
	stx A0,(I6)	; sty A1,(i6)

	ldc MR_SAT|MR_INT,mr0
	.import _myModWrPointer
	ldc _myModWrPointer,I7
	ldc 0x8000+MY_MOD_BUF_SIZE-1,i2
	ldc MODU_DATA,I1
// in VS1002 moduOffset is the last var so we can extend it from 1 to 2 words
//#define _moduOffset 0x728
	ldc _moduOffset+1,i4

	// out = in - (moduOffset>>16);
	// moduOffset += out;
	ldy (I7),I3	; ldx (i1),d0
	ldy (i4)-1,a1
	ldc 4096,a0			// Increase speed: multiply with X
	sub d0,a1,d0
	mulss a0,d0	; ldy (i4),a0
	add a,p,a	; sty d0,(i3)*
	sty i3,(i7)
	sty a0,(i4)+1
	sty a1,(i4)

	ldx (I6)-1,A0	; ldy (I6),A1
	resp a0,a1
	ldx (I6)-1,MR0
	ldx (I6)-1,A0	; ldy (I6),A1
	ldx (I6)-1,A2	; ldy (I6),I4
	ldx (I6)-1,D0	; ldy (I6),I1
	ldx (i6)-1,I3	; ldy (I6),I2

	ldc INT_GLOB_ENA,i7
	reti
	stx i7,(i7)	; ldy (i6)-1,i7







#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
/*#define SPI_xCS2  8*/
#define GPIO_BUT  8
#define SPI_MOSI  1 /* DREQ */


	.sect code,SpiSendReceiveMmc
	.export _SpiSendReceiveMmc16
	.export _SpiSendReceiveMmc
_SpiSendReceiveMmc16:
	ldc 16,A1
_SpiSendReceiveMmc:
// auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx d0,(i6)+1	; sty c0,(i6)
	stx lc,(i6)+1	; sty c1,(i6)

	ldc 16,c0
	sub c0,a1,c0
	ashl a0,c0,a0

	ldc SPI_CLK/*|SPI_xCS*/,c0
	ldc 0/*|SPI_xCS*/,d0
	
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)
	ldc SER_DREQ,i7

	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
	// PLL2_0  66/33% clock 4.1 MHz
	//=2.0*12.288/6 = 4.096
	// 2.0*12.288/7 = 3.511

	// PLL3_5  55/45% clock 4.8 MHz
	// 3.5*12.288/7 = 6.144
	// 3.5*12.288/8 = 5.376
	//=3.5*12.288/9 = 4.779
	// 3.5*12.288/10 = 4.3008

#ifdef PLL3_5
	nop
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_DATA-SER_DREQ)	//data out
#else
	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_DATA-SER_DREQ)	//data out
#endif
	ldx (i7)+(GPIO_ODATA-GPIO_DATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1
#ifdef PLL3_5
	nop
	nop
#endif
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
$0:
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0



	.end
