#define ASM
#define STANDALONE
#include "vs1103.h"

	.sect data_x,sci_defaults
	/*SCI_MODE	0xC000*/
	/*SCI_STATUS	0xC001*/
	.org SCI_BASS
#if 1
	.uword 0x0000	/*SCI_BASS	0xC002*/
#else
	.uword 0x33d9   /*Bass + treble */
#endif
	.uword 0xc000	/*SCI_CLOCKF	0xC003 - 0xc000 = 4.0x 12.288MHz*/
	.uword 0x0000	/*SCI_DECODE_TIME 0xC004*/
	.uword 0x0000	/*SCI_AUDATA	0xC005*/
	.uword 0x0000	/*SCI_WRAM	0xC006*/ /* REC gain/AGC -> AICTRL1*/
	.uword 0xFFFF	/*SCI_WRAMADDR	0xC007*/ /* REC max gain -> AICTRL2*/
	.uword 0x0000	/*SCI_HDAT0	0xC008*/
	.uword 0x0000	/*SCI_HDAT1	0xC009*/
	.uword 0x0000	/*SCI_AIADDR	0xC00A*/
	.uword 0x0000	/*SCI_VOL	0xC00B*/
	.uword 0	/*SCI_AICTRL0	0xC00C*/ /* file to play */
	.uword 0	/*SCI_AICTRL1	0xC00D*/
	.uword 0	/*SCI_AICTRL2	0xC00E*/
#if 1
	.uword 0x0000	/*SCI_AICTRL3	0xC00F*/
#else
	//.word 3*2	/*SCI_AICTRL3	0xC00F pause after play */
	.word 2*2	/*SCI_AICTRL3	0xC00F pause before play */
	//.word 1*2	/*SCI_AICTRL3	0xC00F loop */
#endif


#ifdef ENABLE_WATCHDOG
	.sect data_x,wdog
	.org WDOG_CONFIG
	.word 1000
	.word WDOG_RESET_VAL
#endif


	.import __stack
	.sect code,startup
	.export _main
_main:
	.import _ReadFromProgramRam,_WriteToProgramRam
	// Install the idle hook routine 
	// WriteToProgramRamLong(0, ReadFromProgramRam(0x14));
	call _ReadFromProgramRam
	ldc hookfunc,i0
	call _WriteToProgramRam
	ldc 0,i0

	ldc 1,a1	// perform full init
	.import _MyMain
	.export _MyReset
	j _MyMain
_MyReset:
	ldc __stack+1,i6
	j _MyMain
	ldc 0,a1	// perform partial init

	.import _UserHook
hookfunc:
	j _UserHook


	.sect data_y,bss_y
	.export _fileName
_fileName:
	.bss 6

	.end
