#ifndef _FATINFO_H_
#define _FATINFO_H_

#include <vstypes.h>

//#define FATINFO_IN_Y

#define MAX_FRAGMENTS 34 //38

#ifdef ASM
	.import _fatInfo

#define ISFAT32  0
#define FATSTART 1
#define ROOTSTART 3
#define DATASTART 5
#define CURRENTSECTOR 7
#define FILESIZE 9
#define FATSECTORSPERCLUSTER 11
#define BPBROOTENTCNT 12
#define FILSYSTYPE 13

#define _IS_FAT_32                _fatInfo+ISFAT32
#define _fatStart                 _fatInfo+FATSTART
#define _rootStart                _fatInfo+ROOTSTART
#define _dataStart                _fatInfo+DATASTART
#define _currentSector            _fatInfo+CURRENTSECTOR
#define _fileSize                 _fatInfo+FILESIZE
#define _fatSectorsPerCluster     _fatInfo+FATSECTORSPERCLUSTER
#define _BPB_RootEntCnt           _fatInfo+BPBROOTENTCNT

#else

struct FATINFO { /* do not change sizes or order of fields! */
    u_int16 IS_FAT_32;                // _fatInfo+0
    u_int32 fatStart;                 // _fatInfo+1
    u_int32 rootStart;                // _fatInfo+3
    u_int32 dataStart;                // _fatInfo+5
    u_int32 currentSector;            // _fatInfo+7
    u_int32 fileSize;                 // _fatInfo+9
    u_int16 fatSectorsPerCluster;     // _fatInfo+11
    u_int16 BPB_RootEntCnt;           // _fatInfo+12
    u_int16 FilSysType; // _fatInfo+13 to detect FAT12
};

#ifdef FATINFO_IN_Y
extern __y struct FATINFO fatInfo;
#else
extern struct FATINFO fatInfo;
#endif

#endif/*ASM*/

#endif/*_FATINFO_H_*/
