#ifndef STANDALONE_H
#define STANDALONE_H

#define STANDALONE

//VOL_VAL
#define SCI_UI
//#define UART_UI
#define UART_FIFO /*buffered -- but loses buffer at song change!*/

#ifndef MODRECORD_ADDR
#define MODPLAYER_ADDR 2560
#define MODRECORD_ADDR 7680
#define MODCMD_ADDR 13056
#endif

#define ENCODE_SAMPLES 505

#define ADC_BUF_SIZE 512

//#define PLAYER_ADDR   0x0000
//#define RECORDER_ADDR 0x0a00
//#define SET_HEADERS_ADDR 0x1b00
//#define MIDI_ADDR     0x2300

//#define IDENTIFIER_ADDR      8
//#define MIDI_VOL_ADDR       10
//#define ADPCM_VOL_ADDR      12
//#define TRANSPOSE_ADDR      14
//#define DIVIDER_ADDR 16

//#define DIV 6
//#define SAMPLES_PER_KHZ (48/DIV)
//#if 1
//#define WORK_FASTER
//#endif

//#if 1
//#define NO_APPEND
//#endif



#include "fat.h"

#ifndef ASM
#include "vs1103.h"
#ifdef VS1103
#include <general.h>
#include <asmfuncs.h>
#include <ima.h>
#include <imalib.h>
#include <adpcm.h>
#include <midi.h>
#endif
void MyRxInt(void); //For simple-uart protocol

auto s_int16 myrand(void); /* output 0..0x3fff */
extern __y s_int16 mrand_seed;

void SpiLoad(register __i2 short startAddr);

void MyReset();

auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);

auto void SpiSendClocks(void);
auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 topAlignedData,
			       register __a1 numBits);
auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg);
auto void ReadDiskSector(register __a u_int32 sector);
auto void WritePhysicalSectorY(register __d u_int32 sector,
			      register __i3 __y u_int16 *dataBufPtr);
auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);
auto u_int16 InitFileSystem(void);
auto u_int16 InitFileSystemR(void);
auto __y struct FRAGMENT *FragmentList(register __i2 __y struct FRAGMENT *frag,
			  register __b u_int32 fatCluster);
auto s_int16 HandleDir(register __i2 __y struct FRAGMENT *curFragment,
		       __y struct FRAGMENT *nextFragment);
auto s_int16 OpenFile(register __c0 u_int16 fileNum);
auto s_int16 CheckFileType(register __a u_int32 name);

void SpiLoad2(register __i2 short startAddr, register __i0 short m24);


/*Used for SPI recorder only for now */
struct COMMON {
  u_int16 files;
  u_int16 volume;
  u_int16 uiNum;
  u_int16 uiLoops;
  u_int32 blocks; /* size of the SPI FLASH or 0 for unknown */
  u_int16 record;
  u_int16 command;
};

extern struct COMMON common;

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/
void putstrp(register __i2 const char *s);
#define SWAP(z) ((u_int16)(((u_int16)(z)>>8)|((u_int16)(z)<<8)))
void BusyWait10(void); /* 10ms at 1.0x 12MHz */

auto u_int16 Swap16(__a0 u_int16 t);
auto void PatchInitHardware(void);

#endif/*!ASM*/

#endif/*STANDALONE_H*/
