#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include <parametric.h>
#include <general.h>

auto void PatchInitHardware(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/
auto void play_frame(void);

//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

extern __y u_int16 hwSampleRate;


#if defined(USE_BUTTON)
__y struct {
    u_int16 Data; /* must be first entry! Used by c.s */
    u_int16 Cnt;
    u_int16 Strobe;
    u_int16 Timer; /* Data,Cnt,Strobe,Timer must be in this order (buts.s) */
    u_int16 Key;
    s_int16 KeyTime;
#ifdef KEYTIMER
    s_int16 KeyTimer;
#endif
} ui;
#endif

#if 1

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n);
#endif/*USE_BUTTON*/

#else/*1*/

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n) {
    /*Don't check mode, all we get is APPL_AUDIO.*/
    //if (mode == APPL_AUDIO)
    {
	register u_int16 t = hwSampleRate/16;
	/* generate a timebase for User Interface */
	ui.Cnt += n;
	if (ui.Cnt > t) {
	    ui.Cnt -= t;
	    ui.Timer++;
	    ui.Strobe = 1;
	}
    }
}
#endif/*USE_BUTTON*/
#endif

u_int16 ClockSdi(void); /* dummy return value */
#if 0
u_int16 ClockSdi(void) {
    register int i;
    for (i=0;i<32;i++) {
	USEX(SER_DREQ) = 1;
	USEX(SER_DREQ) = 0;
    }
    return -1;
}
#endif


/*
  Called before HALT
 */
void UserHook(void) {

#ifdef USE_BUTTON
    if (ui.Strobe) {
	ui.Strobe = 0;
	ui.Data = (USEX(GPIO_IDATA) & (1<<3));
	if (ui.Data == ui.Key) {
	    if (ui.KeyTime < 12) {
		ui.KeyTime++;
	    } else if (ui.Key && ui.KeyTime > 0) {
		/* long presses */
		if (ui.Key && ui.KeyTime == 12/*one-shot*/) {
		    ui.KeyTime = 13;
		    /* Volume toggle */
		    USEX(SCI_VOL) ^= 0x1818;
		    SetVolumeFromSpi();
		}
	    }
	} else {
	    if (ui.Data == 0 && ui.KeyTime > 0) {
		/* short presses */
		if (ui.KeyTime < 12) {
		key:
		    /* was pressed < 0.75 seconds */
		    if (ui.Key) {
#if 0 /* for pause-after-play */
			if (USEX(SCI_AICTRL3) & CTRL3_PAUSE_ON) {
			    /* pause -> next file */
			    USEX(SCI_AICTRL0) += 0x8001;
			} else {
			    /* play -> pause */
			    USEX(SCI_AICTRL3) |= CTRL3_PAUSE_ON;
			}
#else /* for pause-before-play */
			if (USEX(SCI_AICTRL3) & CTRL3_PAUSE_ON) {
			    /* pause -> play */
			    USEX(SCI_AICTRL3) &= ~CTRL3_PAUSE_ON;
			} else {
			    /* play -> next file */
			    USEX(SCI_AICTRL0) += 0x8001;
			}
#endif
		    }
		}
	    }
	    ui.Key = ui.Data;
	    ui.KeyTime = 0;
	}
    }
#endif
}


extern s_int16 rtmidi_int_vecs; /* Actually in code memory! */
extern s_int32 __y moduOffset;

auto void MyMain(register s_int16 __a1 fullReset) {
    //USEX(SCI_VOL) = 0x0000; //0dB
    USEX(SCI_VOL) = 0x0c0c; //-6dB
    //USEX(SCI_VOL) = 0x1010; //-8dB
    //USEX(SCI_VOL) = 0x1818; //-12dB

    USEX(SCI_MODE) &= ~(1<<SCIMB_OUT_OF_WAV);
    USEX(SCI_MODE) |= (1<<SCIMB_SDI_NEWMODE);
#if 0 //For vs1103 greeting card player
    USEX(SCI_MODE) |= (1<<SCIMB_DIFFERENTIAL);
#endif
#ifdef USE_BUTTON
    USEX(GPIO_DDR)   = SPI_xCS|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_xCS2;
#else
    USEX(GPIO_DDR)   = SPI_xCS|SPI_CLK|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_xCS2;
#endif

#if 0
    /* 'wake up' spi memory */
//    USEX(GPIO_ODATA) &= ~SPI_xCS;
//    SpiSendReceiveSpi((SPI_READ<<8), 8);
//    SpiSendReceiveSpi(sector<<1, 16);
    SpiSendReceiveSpi(0, 8);
//    USEX(GPIO_ODATA) |= SPI_xCS;
#endif

    USEX(SCI_CLOCKF) = 0x9800; //3.0x

    PatchInitHardware(); /* does not clear user area */

    uartByteSpeed = 115200/10;
    SetClockFromSpi();

    InitCommon();

    //AudioInit(); //rather use..
    //AudioSet(2, 44100U);

#if defined(USE_BUTTON)
//    applAddr = ApplAddr;
#endif/*USE_BUTTON*/

    /* Allow DREQ and enable interrupts, VERY IMPORTANT! */
    USEX(INT_ENABLE) = 0;
//    USEX(INT_GLOB_ENA) = 0;
    USEX(INT_GLOB_ENA) = 0;
//    USEX(INT_GLOB_ENA) = 0;

    AudioSet(2, 48000U);
    InitReadFrame();

    /* Set up adc */
    moduOffset = 0x40000000;
    mod_rd_pointer = mod_wr_pointer = modBuf;


    USEX(MODU_DIV) = 12;
    USEX(INT_ENABLE) = INT_EN_ALL|(1<<INT_EN_MODU);
    USEX(SER_DREQ) = 1;
#if defined(ENABLE_WATCHDOG) && defined(KEEP_DRIVERS_OFF)
    /*otherwise keep it in powerdown until MMC found*/
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN1); /* enable ANALOG power */
#endif
    skipMixer = 1;
    USEX(GPIO_DDR) |= (1<<3)|(1<<2)|(1<<1);

    while (1) {
	static s_int16 buf[2*32];
	register s_int16 *p;
	register int i;
	p = buf;
	for (i=0;i<32;i++) {
	    p[1] = p[0] = (random()-RANDOM_MAX/2)>>16;
	    p += 2;
	}
	WmaStereoCopy(buf, 32);

#if 1
	if (ModBufFill() > 32) {
	    register s_int32 pwr = 0;
	    mod_rd_pointer = ModBufCopy(buf, 32);
	    p = buf;
	    for (i=0;i<32;i++) {
		register s_int16 t = *p++;
#if 0
		if (abs(t) > 26000) {
		    putch('o');
		    putch('v');
		    putch('\n');
		}
#endif
		t >>= 4;
		pwr += (s_int32)t * t;
	    }
	    {
		static s_int32 flt = 0;
		static s_int16 okCount = 0;
		register s_int16 t = pwr >> 16;
		flt -= flt/256;
		flt += t;
		t = flt >> 11;
#if 0
/* capsule only */
#define MAX_LIMIT  75
#define GOOD_LIMIT 39 //47 -6dB
#define BAD_LIMIT  10 //27 -12dB 33 -8dB 55 -6/-11dB* 65 -2dB 35 -9dB
#else
/* assembled mic */
#define MAX_LIMIT  86
#define GOOD_LIMIT 39 //47 -6dB
#define BAD_LIMIT  10 //27 -12dB 33 -8dB 55 -6/-11dB* 65 -2dB 35 -9dB
#endif
		if (t >= GOOD_LIMIT && t <= MAX_LIMIT) {
		    if (okCount > 200) {
			USEX(GPIO_ODATA) |= (1<<2);
			USEX(GPIO_ODATA) &= ~(1<<3);
		    } else {
			okCount++;
		    }
		} else {
		    okCount = 0;
		    if (t <= BAD_LIMIT) {
			USEX(GPIO_ODATA) &= ~(3<<2);
		    } else {
			USEX(GPIO_ODATA) |= (1<<3);
		    }
		}
		{
		    static s_int16 oldT = -1;
		    if (abs(oldT - t) > 1) {
			//putch('0'+t/10000);
			//putch('0'+(t/1000)%10);
			putch('0'+(t/100)%10);
			putch('0'+(t/10)%10);
			putch('0'+t%10);
			putch('\n');	
			oldT = t;
		    }
		/*
		  -6dB:
		  50 19 64 59 56 54 53 53 47 30 40
		  51 49 41 48 37 68 62 53 47 56 50
		  55 45 51 39

		  pow
		  19:-11dB
		  30: -7dB   0dB (amp)
		  40: -5dB  +5dB (amp)
		  50: -1dB  +9dB (amp)
		  60: -1dB +12dB (amp)
		  68:  0dB +14dB (amp)
		 */
		}
	    }
	}
#endif
    }
}
