#ifdef SCI_UI
//#define USE_BUTTON /* Wait for button press (in GPIO3) to play a file. */
//#define PAUSE_AT_POWERON /*switches pause-before-play to pause-after-play*/
#endif

#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include "vs1103.h"
#ifdef UART_FIFO
#include "uartctrl.h"
#endif

#define SWAP(z) ((u_int16)(((u_int16)(z)>>8)|((u_int16)(z)<<8)))

auto u_int16 Swap16(__a0 u_int16 t);
auto void PatchInitHardware(void);

s_int16 record = 0;

//void SetSourcesFromSpi(void);
//auto void SetDreqSafetyAreaFromSpi(void);


auto void play_frame(void);
//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#define KEEP_DRIVERS_OFF /* .. until MMC located */
#define WITH_SUBDIRECTORIES /* support subdirectories */

#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_I2S_ENABLE        (1<<9) /*VS1053: enable I2S*/
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)

#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)

#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
//#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
//#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02

typedef enum {
    spi_pause=0,
    spi_file,
    spi_seek,
    spi_waitdata,
    spi_data,
    spi_zeros,
    spi_record,
    spi_waitima
} SPISTATE;

SPISTATE spiState, oldSpiState;
s_int16 spiCnt;

#include "spifs.h"
#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_4K_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

s_int16 SpiGetStatus(void) {
  __mem_y s_int16 t;
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((SPI_EEPROM_COMMAND_READ_STATUS_REGISTER<<8), 8);
  t = SpiSendReceiveSpi(0, 8);
  USEX(GPIO_ODATA) |= SPI_xCS;
  return t;
}
void SingleCycleCommand(u_int16 cmd){
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((cmd<<8),8);
  USEX(GPIO_ODATA) |= SPI_xCS;
}
u_int16 SpiWaitStatus(void) {
  u_int16 status;
  while ((status = SpiGetStatus()) & 1)
    ;
  return status;
}

void EeUnprotect(){
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER<<8,8);
  SpiSendReceiveSpi(0x02<<8,8); //Sector Protections Off
  USEX(GPIO_ODATA) |= SPI_xCS;
  SpiWaitStatus();
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
}

#if 0
  if (!EeIsBlockErased(blockn)){ //don't erase if not needed
    // Erase 4K sector
    SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
    SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
    EeUnprotect();
    SPI_MASTER_8BIT_CSLO;
    SpiSendReceiveSpi(SPI_EEPROM_COMMAND_ERASE_4K_SECTOR);
    SpiSendReceive(blockn>>7);            // Address[23:16] = blockn[14:7]
    SpiSendReceive((blockn<<1)&0xff);     // Address[15:8]  = blockn[6:0]0
    SpiSendReceive(0);                    // Address[7:0]   = 00000000
    SPI_MASTER_8BIT_CSHI;
  }

  if (SpiWaitStatus() == -1) return -1; /* USB HAS BEEN RESET */

  // Write 8 512-byte sectors
  { 
    u_int16 i;
    for (i=0; i<8; i++){
      
      // Put first page (256 bytes) of sector.
      EeUnprotect();
      SPI_MASTER_8BIT_CSLO;
      SpiSendReceive(SPI_EEPROM_COMMAND_WRITE);
      SpiSendReceive(blockn>>7);            // Address[23:16] = blockn[14:7]
      SpiSendReceive((blockn<<1)&0xff);     // Address[15:8]  = blockn[6:0]0
      SpiSendReceive(0);                    // Address[7:0]   = 00000000
      SPI_MASTER_16BIT_CSLO;
      {
	u_int16 n;
	for (n=0; n<128; n++){
#if USE_INVERTED_DISK_DATA
	  SpiSendReceive(~(*dptr++));
#else
	  SpiSendReceive((*dptr++));
#endif
	}
      }
      SPI_MASTER_8BIT_CSHI;
      if (SpiWaitStatus() == -1) return -1; /* USB HAS BEEN RESET */
#endif



auto void ReadDiskSector(register __a u_int32 sector) {
    register s_int16 i;
    register u_int16 *buffer = stream_buffer;

    USEX(GPIO_ODATA) |= SPI_xCS;
    USEX(GPIO_DDR)   |= SPI_xCS;
    USEX(GPIO_ODATA) &= ~SPI_xCS;
    SpiSendReceiveSpi((SPI_READ<<8), 8);
    /* convert logical to physical */
    SpiSendReceiveSpi((sector+SPIFSSTARTBLOCK)<<1, 16);
    SpiSendReceiveSpi(0, 8);
    for (i=0;i<512/2;i++) {
	*buffer++ = SpiSendReceiveSpi(0, 16);
    }
    USEX(GPIO_ODATA) |= SPI_xCS;
}

auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);

__y u_int16 fileName[6];

u_int32 fileSize = 0, fileStart = 0;
 u_int16 fileEntry = 0, dirBlock = 0;
u_int32 spiSize;
u_int32 spiPage; /* Address counted in 256-byte write pages. */


/* Return first free data block and index to the free file entry.
 */
__mem_y u_int32 dataStart, freeStart = 0;
u_int32 FindEntry(u_int16 *dirline, u_int16 *dirblock) {
    register __c1 int i = 12;
    u_int32 currentSector;

#ifdef ENABLE_WATCHDOG
    USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif
    /* see spifs.h - ident, numHeaderBlocks, reserved, max 25 file entries*/
    ReadDiskSector(currentSector = 0);
    dataStart = GetLong(4); /* number of header blocks */
    while (1) {
	register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */

	/* We are now looking at a directory entry. */
	/* Is current file a regular file? */
	if (fn == 0 || fn == 0xff) {
	  if (dirblock) {
	    *dirblock = (u_int16)currentSector;
	  }
	  if (dirline) {
	    *dirline = i;
	  }
	  goto eod; /*end of directory*/
	}
	/* FILE entry - the space for next file starts immediately after
	   this file. */
	memcpyXY(fileName, stream_buffer+i/2, 6);
	freeStart = GetLong(i+12) + (GetLong(i+16)+511)/512;
	i = (i + 20); /* 20 bytes per entry */
	if (i >= 512) {
	    currentSector++;
	    i = 12;
	    if (currentSector >= dataStart) {
	eod:
	      return freeStart + dataStart + SPIFSSTARTBLOCK;
	    }
	    ReadDiskSector(currentSector);
	}
    }
}
/*
  Insert the file entry. Only writes the relevant 20 bytes.
 */
void MakeEntry(u_int32 bytes, u_int16 dirLine, u_int16 dirBlock) {
  register u_int16 *p = stream_buffer + dirLine/2;
  u_int32 addr = (u_int32)(dirBlock+SPIFSSTARTBLOCK)*512 + dirLine;

  USEX(GPIO_ODATA) |= SPI_xCS;
  //putstrp("\pMakeEntry\n");
  //putword(dirLine);
  //putword(dirBlock);
  //putword(addr>>16);
  //putword(addr);

  ReadDiskSector(dirBlock); /* contains + SPIFSSTARTBLOCK */

  memcpyYX(p, fileName, 6);
  if (*p != (('R'<<8) | 'E')) {
    memcpy(p, "\pRECORD00   ", 6);
  }
  p += 3;
  if ((*p & 0xff) >= '9') {
    *p += 0x100-9;
  } else {
    *p = *p + 1;
  }
  p += 3;
  *p++ = Swap16(freeStart);
  *p++ = Swap16(freeStart>>16);
  *p++ = Swap16(bytes);
  *p++ = Swap16(bytes>>16);

  EeUnprotect();
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,16);
  SpiSendReceiveSpi(addr,16);
  p = stream_buffer+dirLine/2;
  {
    u_int16 n;
    for (n=0; n<20/2; n++){ /* 20 bytes per entry */
      SpiSendReceiveSpi(*p++,16);
    }
  }
  USEX(GPIO_ODATA) |= SPI_xCS;
  
  SpiWaitStatus();
  common.files++;
}


extern __y u_int16 hwSampleRate;
u_int16 __x * __x stream_save;

#if defined(USE_BUTTON)
__mem_y struct {
    u_int16 Data; /* must be first entry! Used by c.s */
    u_int16 Cnt;
    u_int16 Strobe;
    u_int16 Timer; /* Data,Cnt,Strobe,Timer must be in this order (buts.s) */
    u_int16 Key;
    s_int16 KeyTime;
#ifdef KEYTIMER
    s_int16 KeyTimer;
#endif
} ui;
#endif

#if 1

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n);
#endif/*USE_BUTTON*/

#else/*1*/

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n) {
    /*Don't check mode, all we get is APPL_AUDIO.*/
    //if (mode == APPL_AUDIO)
    {
	register u_int16 t = hwSampleRate/16;
	/* generate a timebase for User Interface */
	ui.Cnt += n;
	if (ui.Cnt > t) {
	    ui.Cnt -= t;
	    ui.Timer++;
	    ui.Strobe = 1;
	}
    }
}
#endif/*USE_BUTTON*/
#endif


void FormatDisk(void) {
   USEX(GPIO_ODATA) |= SPI_xCS;
#if 1
   SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
   SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
   EeUnprotect();
#else
   /* Erase Chip takes too long. */
   USEX(GPIO_ODATA) &= ~SPI_xCS;
   SpiSendReceiveSpi((SPI_EEPROM_COMMAND_WRITE_ENABLE<<8),8);
   USEX(GPIO_ODATA) |= SPI_xCS;
#endif

   USEX(GPIO_ODATA) &= ~SPI_xCS;
   SpiSendReceiveSpi(SPI_EEPROM_COMMAND_ERASE_4K_SECTOR<<8,8);
   SpiSendReceiveSpi(SPIFSSTARTBLOCK<<1,16);
   SpiSendReceiveSpi(0,8);
   USEX(GPIO_ODATA) |= SPI_xCS;

   SpiWaitStatus();
   common.files = 0;

   /* Then set the required field: numHeaderBlocks to 8 for 4kB alignment. */
   SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
   USEX(GPIO_ODATA) &= ~SPI_xCS;
   SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,8);
   SpiSendReceiveSpi(SPIFSSTARTBLOCK<<1,16);
   SpiSendReceiveSpi(4<<8,8);
   /* Align to 4kB to allow overwrites. */
   SpiSendReceiveSpi(0x0800,16); /* Reserve 4kB - Little-endian... */
   SpiSendReceiveSpi(0x0000,16);
   USEX(GPIO_ODATA) |= SPI_xCS;
  
   SpiWaitStatus();
}

/*
  Called before HALT
 */

extern u_int16 extClock4KHz, intClock2KHz, clockX, clockA, clockMaxA, oldClock4KHz;
void main(void) {
#if defined(SCI_UI) && defined(ENABLE_WATCHDOG)
    USEX(WDOG_CONFIG) = 1000;
    USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif

    USEX(SCI_STATUS) &= ~((1<<SCIST_APDOWN1)|(1<<SCIST_APDOWN2));

#ifdef UART_FIFO
    //UartInit();
#endif

#if defined(USE_BUTTON)
    applAddr = ApplAddr;
#else
    applAddr = NULL;
#endif/*USE_BUTTON*/

    putstrp("\preccmd here...\n");
    Enable();

    /* determine number of playable files */
    {
      fileStart = FindEntry(&fileEntry, &dirBlock);
      putstrp("\pfileStart");
      putword(fileStart>>16);
      putword(fileStart);
      putch(' ');
      putword(fileEntry);
      putch('\n');
    }
 again:
    stream_rd_pointer = stream_wr_pointer = stream_buffer;
    stream_rd_odd = 0;

    switch (common.command) {
    case 'F':
      putstrp("\pFormat\n");
      FormatDisk();
      break;

    default:
      putch(common.command);
      putstrp("\p - unimplemented\n");
      break;
    }

    putstrp("\pCommand done.\n");

    Disable();
    //SpiLoad2(MODPLAYER_ADDR+3, 1);
    SpiLoad2(3, 1);
}
