#ifdef SCI_UI
//#define USE_BUTTON /* Wait for button press (in GPIO3) to play a file. */
//#define PAUSE_AT_POWERON /*switches pause-before-play to pause-after-play*/
#endif

#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include "vs1103.h"
#include "general.h"
#include "adpcm.h"
#include "midi.h"
#include "parametric.h"
#ifdef UART_FIFO
#include "uartctrl.h"
#endif

auto void PatchInitHardware(void);

u_int16 record = 0;

//void SetSourcesFromSpi(void);
//auto void SetDreqSafetyAreaFromSpi(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/

void putstrp(register __i2 const char *s) {
	while (1) {
		if (!(*s & 0xff00))
			break;
		putch15(*s);
		if (!(*s & 0xff))
			break;
		putch(*s++);
	}
}

auto void play_frame(void);
//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#define KEEP_DRIVERS_OFF /* .. until MMC located */
#define WITH_SUBDIRECTORIES /* support subdirectories */

#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_I2S_ENABLE        (1<<9) /*VS1053: enable I2S*/
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)

#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)

#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02

typedef enum {
    spi_pause=0,
    spi_file,
    spi_seek,
    spi_waitdata,
    spi_data,
    spi_zeros,
    spi_record,
    spi_waitima
} SPISTATE;

SPISTATE spiState, oldSpiState;
s_int16 spiCnt;

#include "spifs.h"
auto void ReadDiskSector(register __a u_int32 sector) {
	register s_int16 i;
	register u_int16 *buffer = stream_buffer;

	sector += SPIFSSTARTBLOCK; /* convert logical to physical */

	USEX(GPIO_ODATA) |= SPI_xCS;
	USEX(GPIO_DDR)   |= SPI_xCS;
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((SPI_READ<<8), 8);
	SpiSendReceiveSpi(sector<<1, 16);
	SpiSendReceiveSpi(0, 8);
	for (i=0;i<512/2;i++) {
		*buffer++ = SpiSendReceiveSpi(0, 16);
	}
	USEX(GPIO_ODATA) |= SPI_xCS;
}

auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);

extern __y u_int16 fileName[6];

u_int16 gFileNum[2];
u_int32 fileSize, fileStart = 0;
u_int32 spiSize;
u_int32 spiAddr;

auto s_int16 OpenFile(register __c0 u_int16 fileNum) {
	register __c1 int i = 12;
	u_int32 currentSector;
	__mem_y u_int32 dataStart;

	gFileNum[0] = fileNum;
	gFileNum[1] = 0;
#ifdef ENABLE_WATCHDOG
	USEX(WDOG_RESET) = WDOG_RESET_VAL;
#endif
	/* see spifs.h - ident, numHeaderBlocks, reserved, max 25 file entries*/
	ReadDiskSector(currentSector = 0);
	dataStart = GetLong(4); /* number of header blocks */
	if (dataStart == 0xffffffffUL) {
	  /* Uninitialized disk - guess it. */
	  dataStart = 8;
	}
	while (1) {
		register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */
		/* We are now looking at a directory entry. */
		/* Is current file a regular file? */
		if (fn == 0 || fn == 0xff) {
			goto eod; /*end of directory*/
		}
#if defined(SCI_UI)
		if (USEX(SCI_AICTRL3) & CTRL3_BY_NAME) {
			register int j, t = 0;
			register u_int16 *p = stream_buffer + i/2;
			register __mem_y u_int16 *d = fileName;
			p[5] &= 0xff00; /* clear the attribute byte */
			for (j=0; j<6; j++) {
				t |= *d++ ^ *p++;
			}
			if (t == 0) {
				USEX(SCI_AICTRL0) = gFileNum[1];
				goto thisfile;
			}
		}
#endif
		gFileNum[1]++;
		if (gFileNum[0]-- == 0) {
			thisfile:
#ifdef SCI_UI
			/* Put the 8.3-character filename to memory so the user
				can read it. Two bytes per word, big-endian. */
			{   /* 13 words */
				register int j;
				register u_int16 *p = stream_buffer + i/2;
				register __y u_int16 *d = fileName;
				for (j=0;j<6;j++) {
					*d++ = *p++;
				}
			}
#endif
			/* ------------ FILE FOUND ------------- */
			fileSize = GetLong(i+16);
			fileStart = dataStart + GetLong(i+12) + SPIFSSTARTBLOCK;
			return -1; /* File found, All OK return */
		}
		i = (i + 20); /* 20 bytes per entry */
		if (i >= 512) {
			currentSector++;
			i = 12;
			if (currentSector >= dataStart) {
				eod:
#if defined(SCI_UI)
				USEX(SCI_AICTRL3) &= ~CTRL3_BY_NAME;
#endif
				return gFileNum[1];
			}
			ReadDiskSector(currentSector);
		}
	}
}



extern __y u_int16 hwSampleRate;
u_int16 __x * __x stream_save;

#if defined(USE_BUTTON)
__mem_y struct {
    u_int16 Data; /* must be first entry! Used by c.s */
    u_int16 Cnt;
    u_int16 Strobe;
    u_int16 Timer; /* Data,Cnt,Strobe,Timer must be in this order (buts.s) */
    u_int16 Key;
    s_int16 KeyTime;
#ifdef KEYTIMER
    s_int16 KeyTimer;
#endif
} ui;
#endif

#if 1

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
					register __a0 s_int16 n);
#endif/*USE_BUTTON*/

#else/*1*/

#if defined(USE_BUTTON)
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode, register __a0 s_int16 n) {
	/*Don't check mode, all we get is APPL_AUDIO.*/
	//if (mode == APPL_AUDIO)
	{
		register u_int16 t = hwSampleRate/16;
		/* generate a timebase for User Interface */
		ui.Cnt += n;
		if (ui.Cnt > t) {
			ui.Cnt -= t;
			ui.Timer++;
			ui.Strobe = 1;
		}
	}
}
#endif/*USE_BUTTON*/
#endif

u_int16 ClockSdi(void); /* dummy return value */
#if 0
u_int16 ClockSdi(void) {
	register int i;
	for (i=0;i<32;i++) {
		USEX(SER_DREQ) = 1;
		USEX(SER_DREQ) = 0;
	}
	return -1;
}
#endif

s_int16 hcShift;
#ifdef UART_FIFO
u_int16 uiNum = 0;
s_int16 uiLoops = -1;
#endif/*UART_FIFO*/

#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_4K_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

s_int16 SpiGetStatus(void) {
	__mem_y s_int16 t;
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((SPI_EEPROM_COMMAND_READ_STATUS_REGISTER<<8), 8);
	t = SpiSendReceiveSpi(0, 8);
	USEX(GPIO_ODATA) |= SPI_xCS;
	return t;
}
#if 0
void SingleCycleCommand(u_int16 cmd){
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi((cmd<<8),8);
	USEX(GPIO_ODATA) |= SPI_xCS;
}
#endif
u_int16 SpiWaitStatus(void) {
	u_int16 status;
	while ((status = SpiGetStatus()) & 1)
		;
	return status;
}

/*
  Called before HALT
 */
void UserHook(void) {
	register __c1 SPISTATE cachedSpiState = spiState;

//USEX(UART_DATA) = spiState;

#if defined(UART_FIFO)
	if (UartFill()) {
		register int cmd = UartGetByte();
		if (cmd == 0xef) { /* Jump to monitor */
			Disable();
			Monitor();
		} else if (cmd == 'M') { /* Record from mic input */
			USEX(SCI_MODE) &= ~(1<<SCIMB_LINE);
			goto rec;
		} else if (cmd == 'R') { /* Record from line input */
			USEX(SCI_MODE) |= (1<<SCIMB_LINE);
			rec:
			Disable();
			USEX(GPIO_ODATA) |= SPI_xCS; /* finish up the read */
			SpiLoad2(MODRECORD_ADDR+3, 1);
		} else if (cmd == 'F') { /* Format -- requires parameter! */
			if (uiNum == 239) {
				/* Format disk */
				common.command = 'F';
				Disable();
				USEX(GPIO_ODATA) |= SPI_xCS; /* finish up the read */
				SpiLoad2(MODCMD_ADDR+3, 1);
			}
		} else if (cmd == 'V') { /* Set direct volume */
			USEX(SCI_VOL) = (uiNum & 255) * 0x0101;
			uiNum = 0;
			goto showvol;
		} else if (cmd == 'P') { /* play file num */
			USEX(SCI_AICTRL0) = uiNum;
			uiNum = 0;
			/*Note: \n is not received, because we restart the software.
			So, we clear uiNum here. */
			goto cancelpauseoff;
		} else if (cmd == '\n' || cmd == '\r') {
			uiNum = 0;
		} else if (cmd >= '0' && cmd <= '9') {
			uiNum = uiNum*10 + cmd - '0';
		} else if (cmd == 'f') {
			/* file mode */
			USEX(SCI_AICTRL3) &= ~CTRL3_PLAY_MODE_MASK;
			USEX(SCI_AICTRL3) |= CTRL3_PAUSE_BEFORE_PLAY;
			//	    putch('f');
		} else if (cmd == 'c') {
			/* continuous play mode */
			USEX(SCI_AICTRL3) &= ~CTRL3_PLAY_MODE_MASK;
			//	    putch('c');
		} else if (cmd == 'l') {
			USEX(SCI_AICTRL3) &= ~CTRL3_PLAY_MODE_MASK;
			USEX(SCI_AICTRL3) |= CTRL3_LOOP_SONG;
			if (uiNum) {
				uiLoops = uiNum; //loop this many times
			}
			uiNum = 0;
			//	    putch('l');
		} else if (cmd == 'C') { /* cancel play: replay the same file */
			//	    putch('C');
			//	    record = 0;
			goto cancelpauseoff;
			//cs.cancel = 1;
			//player.pauseOn = 0;
		} else if (cmd == '+') {
			if (USEX(SCI_VOL)) {
				USEX(SCI_VOL) -= 0x0101; //KeyEventHandler(ke_volumeUp2);
			}
			goto showvol;//putword(player.volume);
		} else if (cmd == '-') {
			//KeyEventHandler(ke_volumeDown2);
			USEX(SCI_VOL) += 0x0101;
			showvol:
			SetVolumeFromSpi();
			common.volume = USEX(SCI_VOL);
			putch(common.volume);
		} else if (cmd == '=') {
			/* pause */
			#ifdef SCI_UI
			USEX(SCI_AICTRL3) |= CTRL3_PAUSE_ON;
			#else
			/* play pause/continue -- not very good for midi.. */
			if (cachedSpiState != spi_pause) {
				oldSpiState = cachedSpiState;
				cachedSpiState = spi_pause;
				stream_save = stream_wr_pointer;
				stream_wr_pointer = stream_rd_pointer+1;
			}
			#endif/*else SCI_UI*/
			//player.pauseOn = 1;
			goto echo;//putch('=');
		} else if (cmd == '>') {
			/* play */
			#ifdef SCI_UI
			USEX(SCI_AICTRL3) &= ~CTRL3_PAUSE_ON;
			#else
			if (cachedSpiState == spi_pause) {
				cachedSpiState = oldSpiState;
				/* restore 'stolen' data */
				stream_wr_pointer = stream_save;
			}
			#endif
			//player.pauseOn = 0;
			parametric_x.midiConfig = 0; /* play speed 0 and reverb auto */
			goto echo;//putch('>');
			#if 1
		} else if (cmd == '') {
			/* Fast forward */
			//if (cs.fastForward < 4)
			//++cs.fastForward;
			/* increase play speed */
			if ((parametric_x.midiConfig & 0x70) < 0x70) {
				parametric_x.midiConfig += 0x10;
			}
			putch(((s_int16)parametric_x.midiConfig>>4) & 7);
			#endif
		} else if (cmd == 'n') {
			/* next */
			//player.nextFile = player.currentFile + 1;
			USEX(SCI_AICTRL0)++;
			putch('n');
			goto cancelpauseoff;
			//cs.cancel = 1;
			//player.pauseOn = 0;
		} else if (cmd == 'p') {
			/* previous */
			//player.nextFile = player.currentFile - 1;
			if (USEX(SCI_DECODE_TIME) < 5) {
				if (USEX(SCI_AICTRL0)) {
					USEX(SCI_AICTRL0)--;
				} else {
					USEX(SCI_AICTRL0) = common.files - 1;
				}
			}
			putch('p');
	
			cancelpauseoff:
			//cs.cancel = 1;
			//player.pauseOn = 0;
			USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
			#ifdef SCI_UI
			USEX(SCI_AICTRL0) |= 0x8000U;
			#else
			;
			#endif
	
			#if 1
		} else if (cmd == '?') {
			/* position + other info -- Note: will block. */
			putword(USEX(SCI_DECODE_TIME));
			putch((fileSize-2*spiSize) / ((fileSize >> 8)+1));
			#endif
		} else {
			/*unknown command*/
			echo:
			putch(cmd);
		}
	}
	#endif/*UART_FIFO*/
	
	#if defined(UART_UI)
	if ((USEX(SCI_AICTRL3) & CTRL3_UPDATE_VOL)) {
		USEX(SCI_AICTRL3) &= ~CTRL3_UPDATE_VOL;
		SetVolumeFromSpi();
	}
	#endif/*UART_UI*/
	
	
	#ifdef SCI_UI
	/* play pause/continue */
	if ((USEX(SCI_AICTRL3) & CTRL3_PAUSE_ON)) {
		if (cachedSpiState != spi_pause) {
			oldSpiState = cachedSpiState;
			#if defined(UART_UI) || defined(UART_FIFO)
			putch('p');//pause
			#endif
			cachedSpiState = spi_pause;
			stream_save = stream_wr_pointer;
			stream_wr_pointer = stream_rd_pointer+1;
			/* Does not matter if it is one off..
			StreamDiff() returns the right value regardless. */
		}
	} else {
		if (cachedSpiState == spi_pause && oldSpiState != spi_pause) {
			#if defined(UART_UI) || defined(UART_FIFO)
			putch('c');//continue
			#endif
			cachedSpiState = oldSpiState;
			stream_wr_pointer = stream_save;
		}
	}
	if ((USEX(SCI_AICTRL0) & 0x8000U)) {
		/* new song */
		USEX(SCI_AICTRL0) &= 0x7fff; /* ack command */
		/*NEW: clear pause and file ready bits automatically */
		USEX(SCI_AICTRL3) &= ~(CTRL3_PAUSE_ON | CTRL3_FILE_READY | CTRL3_AT_END);
		USEX(GPIO_ODATA) |= SPI_xCS;
		#ifdef UART_UI
		putch('C');//USEX(UART_DATA) = 'C';
		#endif
		/* Jump to new track immediately */
		#if defined(UART_UI) || defined(UART_FIFO)
		//putstrp("\pdone\n\n");
		#endif
		USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
		//MyReset();
	}
	#endif/*SCI_UI*/
	
	#ifdef USE_BUTTON
	if (ui.Strobe) {
		ui.Strobe = 0;
		ui.Data = (USEX(GPIO_IDATA) & (1<<3));
		if (ui.Data == ui.Key) {
			if (ui.KeyTime < 12) {
				ui.KeyTime++;
			} else if (ui.Key && ui.KeyTime > 0) {
				/* long presses */
				if (ui.Key && ui.KeyTime == 12/*one-shot*/) {
					ui.KeyTime = 13;
					/* Volume toggle */
					USEX(SCI_VOL) ^= 0x1818;
					SetVolumeFromSpi();
				}
			}
		} else {
			if (ui.Data == 0 && ui.KeyTime > 0) {
				/* short presses */
				if (ui.KeyTime < 12) {
					key:
					/* was pressed < 0.75 seconds */
					if (ui.Key) {
						#if 0 /* for pause-after-play */
						if (USEX(SCI_AICTRL3) & CTRL3_PAUSE_ON) {
							/* pause -> next file */
							USEX(SCI_AICTRL0) += 0x8001;
						} else {
							/* play -> pause */
							USEX(SCI_AICTRL3) |= CTRL3_PAUSE_ON;
						}
						#else /* for pause-before-play */
						if (USEX(SCI_AICTRL3) & CTRL3_PAUSE_ON) {
							/* pause -> play */
							USEX(SCI_AICTRL3) &= ~CTRL3_PAUSE_ON;
						} else {
							/* play -> next file */
							USEX(SCI_AICTRL0) += 0x8001;
						}
						#endif
					}
				}
			}
			ui.Key = ui.Data;
			ui.KeyTime = 0;
		}
	}
	#endif
	
	#define SW1 0xffffU
	#define SW2 0x8000U
	#define SW3 0x7fffU
	
	#ifndef USE_DEBUG
	
	#ifdef PLAYTIME
	if (USEX(SCI_DECODE_TIME) > PLAYTIME && cachedSpiState != spi_zeros) {
		USEX(SCI_AICTRL0)++;
		USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
		cachedSpiState = spi_zeros;
	}
	#endif/*PLAYTIME*/

	if (cachedSpiState == spi_file) {
		/* extra byte read if odd file size */
		spiSize = (fileSize+1)/2; /* in words! */
		//spiAddr = (fileStart<<9);
		spiCnt = 0;
	
		/* Start one big read from the beginning of the file. */
		USEX(GPIO_ODATA) &= ~SPI_xCS;
		SpiSendReceiveSpi((SPI_READ<<8), 8);
		SpiSendReceiveSpi(fileStart<<1, 16);
		SpiSendReceiveSpi(0, 8);
		cachedSpiState = spi_data;
	
	} else if (cachedSpiState == spi_data) {
		while (StreamDiff() < STREAM_BUFFER_SZ-40 && spiSize > 0) {
			register int i, j = 32;
			register u_int16 *wr = (void *)stream_wr_pointer;
			if (j > spiSize) {
				j = spiSize;
			}
			for (i=0;i<j;i++) {
				*wr++ = SpiSendReceiveSpi(0,16);
				if (wr >= &stream_buffer[STREAM_BUFFER_SZ]) {
					wr = stream_buffer;
				}
			}
			stream_wr_pointer = (void *)wr;
			spiSize -= j;
			/* watchdog clearing here doesn't work with midi */
		}
	
		#ifdef ENABLE_WATCHDOG
		USEX(WDOG_RESET) = WDOG_RESET_VAL;
		#endif
		if (spiSize == 0) {
			end_of_file:
			USEX(GPIO_ODATA) |= SPI_xCS;
			spiCnt = 0;
			//USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV); not yet!
			#ifdef SCI_UI
			{
				register int m = (USEX(SCI_AICTRL3)& CTRL3_PLAY_MODE_MASK);
				cachedSpiState = spi_zeros;
				if (m == CTRL3_LOOP_SONG) {
					/* restart the same file immediately */
					cachedSpiState = spi_file;
					#ifdef UART_UI
					putch('l');//USEX(UART_DATA) = 'l';
					#endif
					#ifdef UART_FIFO
					putch('l');//USEX(UART_DATA) = 'l';
					if (uiLoops > 0) {
						uiLoops--;
						if (uiLoops == 0) {
							uiLoops = -1; //back to infinite loops
							USEX(SCI_AICTRL3) &= ~CTRL3_PLAY_MODE_MASK;
						}
					}
					#endif
				} else if (m == CTRL3_PAUSE_AFTER_PLAY) {
					/* pause after play
					Note: should be after the zeros have been sent! */
					USEX(SCI_AICTRL3) |= CTRL3_PAUSE_ON | CTRL3_AT_END;
				} else {
					USEX(SCI_AICTRL0) += 1; /* normal play: next file */
				}
			}
			#else/*SCI_UI*/
			{
				register int m = (USEX(SCI_AICTRL3)& CTRL3_PLAY_MODE_MASK);
				if (m == CTRL3_LOOP_SONG) {
					/* restart the same file immediately */
					cachedSpiState = spi_file;
				} else if (m == CTRL3_PAUSE_AFTER_PLAY) {
					/* goto pause mode, so next and prev will work to
					jump to next/prev song.
					Note: should be after the zeros have been sent!
					*/
					oldSpiState = spi_zeros;
					cachedSpiState = spi_pause;
				} else {
					USEX(SCI_AICTRL0) += 1; /* normal play: next file */
					cachedSpiState = spi_zeros;
				}
			}
			#endif/*elseSCI_UI*/
		}
	} else if (cachedSpiState == spi_zeros) {
		if (StreamDiff() < STREAM_BUFFER_SZ-40) {
			register int i, z = 0;
			register u_int16 *wr = (void *)stream_wr_pointer;
			for (i=0;i<32;i++) {
				*wr = z;
				if (wr >= &stream_buffer[STREAM_BUFFER_SZ-1]) {
					wr = stream_buffer;
				} else {
					wr++;
				}
				++spiCnt;
				stream_wr_pointer = (void *)wr;
			}
			/* watchdog clearing here doesn't work with midi */
		}
		if (spiCnt >= 256+2*STREAM_BUFFER_SZ) {
			//goreset:
			USEX(GPIO_ODATA) |= SPI_xCS;
			USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
	
			if (spiCnt >= 256+6*STREAM_BUFFER_SZ) {
				#if defined(UART_UI) || defined(UART_FIFO)
			  //putstrp("\pdone2\n\n");
				#endif
				//USEX(SCI_MODE) |= (1<<SCIMB_OUT_OF_WAV);
				MyReset(); //fallback
			}
		}
		#ifdef ENABLE_WATCHDOG
		goto wdogack;//USEX(WDOG_RESET) = WDOG_RESET_VAL;
		#endif
	} else {
		#ifdef ENABLE_WATCHDOG
		wdogack:
		USEX(WDOG_RESET) = WDOG_RESET_VAL;
		#endif
	}
	
	
	#ifdef SCI_UI
	//    USEX(SER_DREQ) = 0;
	#else
	
	#define NO_DREQ_LED
	#ifndef NO_DREQ_LED
	/* 15 words */
	{
		register int t = 0;
	
		if ((ui.Timer & 0x18) == 0) {
			/* DREQ indicates random play status */
			#ifdef NO_RANDOM
			t = USEX(SCI_BASS); /* has lowest bit set if enabled*/
			#else
			t = USEX(SCI_AICTRL3);  /* lowest bit is global random play */
			#ifdef LOUDNESS_ALWAYS_ON_OFF
			/* indicate random play */
			#else /*LOUDNESS_ALWAYS_ON_OFF*/
	
			if (cachedSpiState
			#ifdef SW3_RANDOM_PLAY
			==
			#else
			!=
			#endif
			spi_pause)
			t = USEX(SCI_BASS); /* has lowest bit set if enabled*/
			#endif /*else LOUDNESS_ALWAYS_ON_OFF*/
			#endif /*else NO_RANDOM*/
		}
		USEX(SER_DREQ) = t;
	}
	#endif/*!NO_DREQ_LED*/
	#endif/*!SCI_UI*/
	#endif/*!USE_DEBUG*/
	
	spiState = cachedSpiState;
	#ifdef KEYTIMER
	#ifdef BATTCHECK
	{
		register s_int16 batt = USEX(MODU_DATA);
		if (ui.KeyTimer >= 0 || ((ui.KeyTimer & 8) == 0 && (batt < 0x240 || ui.KeyTimer > (batt>>7) - 60)))
			USEX(UART_DATA) = 0x00;
	}
	#else
	if (ui.KeyTimer >= 0) {
		USEX(UART_DATA) = 0x00;
	}
	#endif
	#endif/*KEYTIMER*/
}


auto void MyMain(register s_int16 __a1 fullReset) {
	#if 0 && defined(VS1103)
	USEX(SCI_MODE) = (1<<SCIMB_SDI_NEWMODE) + (0<<SCIMB_CONF); /*0=SDIMIDI,SCIWAV 1=SDIWAV,SCIMIDI*/
	#endif
	
	USEX(SCI_VOL) = common.volume;
	SetClockFromSpi();
	
#if 1 /*VERSION*/
	/*
	  v0.6 print version string
	*/
	putword(('R'<<8)|'E');
	putword(('0'<<8)|'.');
	putword(('6'<<8)|'0');
	putch('\n');
#endif
	#ifdef UART_FIFO
	//UartInit();
	#endif
	
	//AudioInit(); //rather use..
	//AudioSet(2, 44100U);
	
	#if defined(USE_BUTTON)
	applAddr = ApplAddr;
	#endif/*USE_BUTTON*/
	
	/* Allow DREQ and enable interrupts, VERY IMPORTANT! */
	USEX(INT_ENABLE) = 0;
	USEX(INT_GLOB_ENA) = 0;
	Enable();
	
	
	again:
	USEX(SCI_MODE) &= ~(1<<SCIMB_OUT_OF_WAV);
	stream_rd_pointer = stream_wr_pointer = stream_buffer;
	stream_rd_odd = 0;
	
	#if !defined(NO_RANDOM) /* no random play feature */
	if ((USEX(SCI_AICTRL3) & CTRL3_RANDOM_PLAY)) {
		/* random play (not shuffle!) */
		USEX(SCI_AICTRL0) = (myrand() % common.files);
	}
	#endif
	if (OpenFile(USEX(SCI_AICTRL0)
	#ifdef SCI_UI
	&= 0x7fffU //max 32768 files in SCI-controlled version
	#endif
	) < 0) {
	
		#if defined(SCI_UI)
		if ((USEX(SCI_AICTRL3) & CTRL3_PLAY_MODE_MASK) ==
		CTRL3_PAUSE_BEFORE_PLAY) {
			/* Mark file ready and go to pause state in UserHook */
			USEX(SCI_AICTRL3) |= CTRL3_PAUSE_ON;
		}
		/*NEW: set FILE_READY always */
		USEX(SCI_AICTRL3) = CTRL3_FILE_READY |
		(USEX(SCI_AICTRL3) & ~CTRL3_AT_END);
		#endif
	
	
		#if defined(PAUSE_AT_POWERON) /*pause at power-on, then use pause after play*/
		#ifdef SCI_UI
		if ((USEX(SCI_AICTRL3) & CTRL3_PLAY_MODE_MASK) ==
		CTRL3_PAUSE_BEFORE_PLAY) {
			USEX(SCI_AICTRL3) = CTRL3_PAUSE_AFTER_PLAY | CTRL3_PAUSE_ON;
		}
		spiState = spi_file;
	
		#else/*SCI_UI*/
		if ((USEX(SCI_AICTRL3) & CTRL3_PLAY_MODE_MASK) ==
			CTRL3_PAUSE_BEFORE_PLAY) {
			USEX(SCI_AICTRL3) = CTRL3_PAUSE_AFTER_PLAY
			#ifdef SCI_UI
			| CTRL3_PAUSE_ON
			#endif
			;
			oldSpiState = spi_file;
			spiState = spi_pause;
			stream_save = stream_wr_pointer;
		} else {
			spiState = spi_file;
		}
		#endif/*elseSCI_UI*/
		#else /*PAUSE_AT_POWERON*/
		spiState = spi_file;
		#endif /*else PAUSE_AT_POWERON*/
		spiCnt = 0;
	
	} else {
		gofirst:
		USEX(SCI_AICTRL0) = 0; /* file not found, jump to first file */
		if (common.files == 0) {
			putstrp("\pstart in pause\n");
			stream_save = stream_wr_pointer;
			oldSpiState = spiState = spi_pause;
			spiCnt = 0;
		} else {
			goto again;
		}
	}
	
	
	#ifdef USE_BUTTON
	ui.Key = (1<<3);
	ui.KeyTime = -32767;
	#endif/*USE_BUTTON*/
	
	#if defined(ENABLE_WATCHDOG) && defined(KEEP_DRIVERS_OFF)
	/*otherwise keep it in powerdown until MMC found*/
	USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN1); /* enable ANALOG power */
	#endif
	
	USEX(INT_ENABLE) = ENABLE_SCI_DAC_RX;
	USEX(SCI_DECODE_TIME) = 0;
	
	#if defined(UART_UI) || defined(UART_FIFO)
	putstrp("\pplay");
	putword(USEX(SCI_AICTRL0));
	if (0 /*common.files == 0*/) {
		putstrp("\p --\n");
	} else {
		#ifdef SCI_UI
		putword(fileName[0]);
		putword(fileName[1]);
		putword(fileName[2]);
		putword(fileName[3]);
		putword(fileName[4]);
		putch15(fileName[5]);
		putch('\n');
		#endif/*SCI_UI*/
	}
	#endif
	/*A modified tradpatch for VS1103B */
	{
		#define MIXER_OUT_SAMPLES 34
		auto s_int16 DecodeHeader(register __d u_int32 head);
		struct Wav {
			s_int16 channels;
			u_int16 sampleRate;
			s_int16 ima;
			s_int16 bitsPerSample;
			s_int16 samplesPerBlock;
			u_int16 imaSync;
			u_int32 samplesLeft;
			u_int16 flags;
		};
		extern struct Wav wav;
		extern s_int16 mixerOut[3][2*MIXER_OUT_SAMPLES];
	
		register u_int32 head = 0;
	
		skipMixer = 1;
		head = 0;
		while (1) {
			if (StreamDiff()) {
				head <<= 8;
				head |= SdiGetC();
				//puthex(head);
				//putch('\n');
				if (head == MAKE_ID('R','I','F','F')) {
					ResetAdpcm();
					#if 1
					/* Move "RIFF" back to input buffer */
					if ((stream_rd_pointer -= 2) < stream_buffer)
					stream_rd_pointer += STREAM_BUFFER_SZ;
					#else
					/* we know we always start from the beginning
					-- except loop! */
					stream_rd_pointer = stream_buffer;
					#endif
					adpcmSource = 0;	/* ADPCM from SDI */
					while (!(USEX(SCI_MODE) & (1<<SCIMB_OUT_OF_WAV))) {
						GetAdpcmSamples(NULL, mixerOut[0], 32);
						if (wav.sampleRate && wav.sampleRate != hwSampleRate) {
							//putword(wav.sampleRate);
							SetHardware(wav.channels, wav.sampleRate);
						}
						WmaStereoCopy(mixerOut[0], 32);
					}
					USEX(SCI_MODE) &= ~(1<<SCIMB_OUT_OF_WAV);
					putstrp("\pdone\n");
					goto again;
				} else if (head == MAKE_ID('M','T','h','d')) {
					//		    USEX(SCI_DECODE_TIME) = 0;
					DecodeHeader(head);
					putstrp("\pdone\n");
					goto again;
				} else {
					/* Unknown */
				  //putword(head>>16);
				  //putword(head);
				  //putstrp("\p ??\n");
				  if (spiSize < 1024 ) {
				    /* eof */
				    putstrp("\pno format\n");
				    goto again;
				  }
				}
			} else {
				/*required for key handling (pause) and data feed */
				memset(pcm_sample, 0, AUDIOBUFSIZE);
				wav_write();
			}
		}
	}
}
