#ifndef SPI_H
#define SPI_H

#ifndef ASM

void SpiLoad2(register __i2 short startAddr, register __i0 short m24);

auto void SpiSendClocks(void);
auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 topAlignedData,
			       register __a1 numBits);
#define SpiPrivSendReceive SpiSendReceiveMmc
auto void SpiPrivInit(void);
auto u_int16 SpiPrivStatus(void);
auto void SpiReadPage(u_int16 pageNo, register u_int16 *d);
auto u_int16 SpiReadWord(u_int32 byteAddr);
void SingleCycle8BitCommand(u_int16 cmd);
void SpiWritePageX(u_int16 pageNo, register __i0 u_int16 *buf);
void SpiWritePageY(u_int16 pageNo, register __i0 u_int16 __y *buf);
void SpiWritePageXY(u_int16 pageNo, register __i0 u_int16 *buf);
auto void SpiFlashUnprotect(void);
auto u_int16 SpiEraseBlock(u_int16 pageNo);


#if 0
auto void SpiPrivDelay(void);
#else
#define SpiPrivDelay() USEX(0)
#endif

#endif /* !ASM */



#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
#define SPI_MISO  4
/*#define SPI_xCS2  8*/
#define GPIO_BUT  8
#define SPI_MOSI  1 /* DREQ */

#define SPI_WREN  0x06
#define SPI_WRDI  0x04
#define SPI_RDSR  0x05
#define SPI_WRSR  0x01
#define SPI_READ  0x03
#define SPI_WRITE 0x02

#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_BLOCK 0xD8
#define SPI_EEPROM_COMMAND_ERASE_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

#define SPI_BLOCK_BITS 16
#define SPI_PAGE_BITS 8
#define SPI_BLOCK_SIZE (1UL<<SPI_BLOCK_BITS)
#define SPI_PAGE_SIZE (1U<<SPI_PAGE_BITS)
#define SPI_PAGES_PER_BLOCK (1U<<(SPI_BLOCK_BITS-SPI_PAGE_BITS))
#if 0
#if 1
#define SPI_SIZE (1UL<<20)
#else
#define SPI_SIZE (1UL<<18)
#endif
#define SPI_PAGES (SPI_SIZE>>SPI_PAGE_BITS)
#else
#define SPI_PAGES 0xFFF1U
#endif


#define SPI_WREN  0x06
#define SPI_WRDI  0x04
#define SPI_RDSR  0x05
#define SPI_WRSR  0x01
#define SPI_READ  0x03
#define SPI_WRITE 0x02



#endif /* !SPI_H */
