#ifndef __SPIFS_H__
#define __SPIFS_H__

#include <vstypes.h>

#define SPIFSSTARTBLOCK 64 //32kB reserved

struct SPIFILEENTRY {
    u_int16 name[6];  /* 8.3 name in packed string format, can contain any chars */
    u_int32 startOffset; /* relative to data start (numHeaderBlocks) Little-Endian! */
    u_int32 fileSize;    /* file size in bytes Little-Endian!*/
    /*20 bytes per entry*/
};

#define SPIFILEENTRIESPERBLOCK 25
struct SPIFS {
    u_int32 ident;           /* only valid on the first block */
    u_int32 numHeaderBlocks; /* only valid on the first block */
    u_int32 reserved;
    struct SPIFILEENTRY f[SPIFILEENTRIESPERBLOCK];
};

#endif /*!__SPIFS_H__*/
