#include <stdio.h>
#define STANDALONE
#define USE_EARSPEAKER
#include <string.h>
#include "module.h"
#include <h1103/hardware.h>
#include <h1103/parametric.h>
#include <h1103/general.h>
#ifdef UART_FIFO
#include "uartctrl.h"
#endif

#define FILENAME "\pVS1103B IMG"

auto void PatchInitHardware(void);

//void SetSourcesFromSpi(void);
//auto void SetDreqSafetyAreaFromSpi(void);

void putch(register __a0 int ch);
void putch15(register __a0 int ch);
void putword(register __a0 int ch);
void Monitor(void); /*never returns*/

#if 1
static char hex[] = "0123456789ABCDEF";
void puthex(u_int16 d) {
    register i;
    for (i=0;i<4;i++) {
	putch(hex[((d>>12)&15)]);
	d <<= 4;
    }
}
#endif

void putstrp(register __i2 const char *s) {
    while (1) {
	if (!(*s & 0xff00))
	    break;
	putch(*s>>8);
	if (!(*s & 0xff))
	    break;
	putch(*s++); //putch(*s++);
    }
}

auto void play_frame(void);
//void Disable();
//void Enable();
//void Reset();

//#undef putchar
//#undef puts

//#include <stdio.h>

#include <stdlib.h>

#ifdef WAIT_FOR_UART_BYTE
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC))
#else
#define ENABLE_SCI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#define ENABLE_SCI_SDI_DAC_RX ((1<<INT_EN_SCI)|(1<<INT_EN_SDI)|(1<<INT_EN_DAC)|(1<<INT_EN_RX))
#endif/*elseWAIT_FOR_UART_BYTE*/


#define KEEP_DRIVERS_OFF /* .. until MMC located */
#define WITH_SUBDIRECTORIES /* support subdirectories */

#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_I2S_ENABLE        (1<<9) /*VS1053: enable I2S*/
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)

#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)

#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#ifndef GPIO_IDATA
#define GPIO_IDATA GPIO_DATA
#endif

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
//#define SPI_CLK   8 /*MMC clk*/
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
//#define SPI_xCS2  2
#define SPI_xCS2  8
#define SPI_MOSI  1 /* DREQ */

//#define SPI_WREN  0x06
//#define SPI_WRDI  0x04
//#define SPI_RDSR  0x05
//#define SPI_WRSR  0x01
#define SPI_READ  0x03
//#define SPI_WRITE 0x02


auto void busywait(void) {
    int i;
    for (i=0;i<10;i++) {
	USEX(SER_DREQ);
    }
}
auto void SpiPrivDelay(void) {
    int i;
    for (i=0;i<10;i++) {
	USEX(SER_DREQ);
    }
}
auto u_int16 SpiPrivSendReceive(register __a0 u_int16 dat,
			    register __a1 s_int16 bits) {
    register u_int16 odata = 0;
    while (bits--) {
	USEX(SER_DREQ) = (dat>>bits);
	SpiPrivDelay();
	USEX(GPIO_ODATA) |= SPI_CLK;
	SpiPrivDelay();
	odata <<= 1;
#if SPI_MISO == 4
	odata |= (USEX(GPIO_IDATA) >> 2) & 1;
#else
	odata |= (USEX(GPIO_IDATA) & SPI_MISO) ? 1 : 0;
#endif
	USEX(GPIO_ODATA) &= ~SPI_CLK;
    }
    return odata;
}



#define 	MMC_GO_IDLE_STATE   0
#define 	MMC_SEND_OP_COND   1
#define 	MMC_SEND_IF_COND   8
#define 	MMC_SEND_CSD   9
#define 	MMC_SEND_CID   10
#define 	MMC_SEND_STATUS   13
#define 	MMC_SET_BLOCKLEN   16
#define 	MMC_READ_SINGLE_BLOCK   17
#define 	MMC_WRITE_BLOCK   24
#define 	MMC_PROGRAM_CSD   27
#define 	MMC_SET_WRITE_PROT   28
#define 	MMC_CLR_WRITE_PROT   29
#define 	MMC_SEND_WRITE_PROT   30
#define 	MMC_TAG_SECTOR_START   32
#define 	MMC_TAG_SECTOR_END   33
#define 	MMC_UNTAG_SECTOR   34
#define 	MMC_TAG_ERASE_GROUP_START   35
#define 	MMC_TAG_ERARE_GROUP_END   36
#define 	MMC_UNTAG_ERASE_GROUP   37
#define 	MMC_ERASE   38
#define         MMC_READ_OCR     58
#define 	MMC_CRC_ON_OFF   59
#define 	MMC_R1_BUSY   0x80
#define 	MMC_R1_PARAMETER   0x40
#define 	MMC_R1_ADDRESS   0x20
#define 	MMC_R1_ERASE_SEQ   0x10
#define 	MMC_R1_COM_CRC   0x08
#define 	MMC_R1_ILLEGAL_COM   0x04
#define 	MMC_R1_ERASE_RESET   0x02
#define 	MMC_R1_IDLE_STATE   0x01
#define 	MMC_STARTBLOCK_READ   0xFE
#define 	MMC_STARTBLOCK_WRITE   0xFE
#define 	MMC_STARTBLOCK_MWRITE   0xFC
#define 	MMC_STOPTRAN_WRITE   0xFD
#define 	MMC_DE_MASK   0x1F
#define 	MMC_DE_ERROR   0x01
#define 	MMC_DE_CC_ERROR   0x02
#define 	MMC_DE_ECC_FAIL   0x04
#define 	MMC_DE_OUT_OF_RANGE   0x04
#define 	MMC_DE_CARD_LOCKED   0x04
#define 	MMC_DR_MASK   0x1F
#define 	MMC_DR_ACCEPT   0x05
#define 	MMC_DR_REJECT_CRC   0x0B
#define 	MMC_DR_REJECT_WRITE_ERROR   0x0D

auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg);

#define PULL_OK  1
#define FLASH_OK 2
#define SD_OK    4

int hcShift = 9;
__y u_int16 fileName[6];
#ifdef FATINFO_IN_Y
__y struct FATINFO fatInfo;
#else
struct FATINFO fatInfo;
#endif
#define LAST_FRAGMENT 0x80000000UL
struct FRAGMENT {
    u_int32 start; /*high bit set if last fragment*/
    u_int16 size;
};
//#define MAX_FRAGMENTS 28//16//22
__y struct FRAGMENT fragments[MAX_FRAGMENTS];
u_int16 gFileNum[2];

/*147 words*/
auto s_int16 HandleDir(register __i2 __y struct FRAGMENT *curFragment,
		       __y struct FRAGMENT *nextFragment) {
  register __c1 int i = 0;
  register u_int32 currentSector = curFragment->start /*& 0x7fffffffUL */;

  goto first;
  
  while (1) {
    register __d1 u_int16 fn = GetByte(i+0); /* first char of filename */
    
    /* We are now looking at FAT directory structure. */
    /* Is current file a regular file? */
    if (fn == 0) {
      goto eod; /*end of directory*/
    }
    if (fn != 0xe5) { /* Not deleted */
      /* Attributes: NO directory, NO volume id, NO system, NO hidden */
      if ((GetByte(i+11/*Attr*/) & 0xde) == 0) {
#ifdef FILENAME
	{
	  register int j, t = 0;
	  register u_int16 *p = stream_buffer + i/2;
	  register const u_int16 *d = FILENAME;
	  p[5] &= 0xff00; /* clear the attribute byte */
	  for (j=0; j<6; j++) {
	    t |= *d++ ^ *p++;
	  }
	  if (t == 0) {
	    USEX(SCI_AICTRL0) = gFileNum[1];
	    goto thisfile;
	  }
	}
#endif
	/* It is a regular file. */
	gFileNum[1]++;
	if (gFileNum[0]-- == 0) {
	thisfile:
#if 0 //def SCI_UI
	  /* Put the 8.3-character filename to memory so the user
	     can read it. Two bytes per word, big-endian. */
	  {   /* 13 words */
	    register int j;
	    register u_int16 *p = stream_buffer + i/2;
	    register __y u_int16 *d = fileName;
	    for (j=0;j<6;j++) {
	      putword(*p);
	      *d++ = *p++;
	    }
	  }
#endif
	  /* ------------ FILE FOUND ------------- */
	  fatInfo.fileSize = GetLong(i+28); /*do first!*/
	  FragmentList(&fragments[0],
		       ((u_int32)GetWord(i+20)<<16) + GetWord(i+26));
	  return -1; /* File found, All OK return */
	}
      } /* normal file */
    } /* 0xe5 / 0x00 deleted or unused entry */
    i = (i + 32) & 511;
    if (i == 0) {
      currentSector++;
      if (--(curFragment->size) == 0) {
	if ((s_int16)(curFragment->start>>16) < 0) {
	eod:
	  return gFileNum[1];
	}
	curFragment++;
	currentSector = curFragment->start /*& 0x7fffffffUL*/;
      }
    first:
#if 0
      puthex(currentSector);
      putstrp("\p read\n");
#endif
      ReadDiskSector(currentSector);
    }
  }
}

#define SPI_EEPROM_COMMAND_WRITE_ENABLE  0x06
#define SPI_EEPROM_COMMAND_WRITE_DISABLE  0x04
#define SPI_EEPROM_COMMAND_READ_STATUS_REGISTER  0x05
#define SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER  0x01
#define SPI_EEPROM_COMMAND_READ  0x03
#define SPI_EEPROM_COMMAND_WRITE 0x02
#define SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS 0x30
#define SPI_EEPROM_COMMAND_ERASE_4K_SECTOR 0x20
#define SPI_EEPROM_COMMAND_ERASE_CHIP 0xC7

s_int16 SpiGetStatus(void) {
  __mem_y s_int16 t;
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((SPI_EEPROM_COMMAND_READ_STATUS_REGISTER<<8), 8);
  t = SpiSendReceiveSpi(0, 8);
  USEX(GPIO_ODATA) |= SPI_xCS;
  return t;
}
void SingleCycleCommand(u_int16 cmd){
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi((cmd<<8),8);
  USEX(GPIO_ODATA) |= SPI_xCS;
}
u_int16 SpiWaitStatus(void) {
  u_int16 status;
  while ((status = SpiGetStatus()) & 1)
    ;
  return status;
}

void EeUnprotect(){
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
  USEX(GPIO_ODATA) &= ~SPI_xCS;
  SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE_STATUS_REGISTER<<8,8);
  SpiSendReceiveSpi(0x02<<8,8); //Sector Protections Off
  USEX(GPIO_ODATA) |= SPI_xCS;
  SpiWaitStatus();
  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
}


void main(void) {
  int okmask = 0;
  /* Test / program */

  USEX(SCI_AICTRL1) = 0;
  USEX(SCI_AICTRL0) = 0xa000; /*Started*/

  uartByteSpeed = 115200/10;
  USEX(INT_ENABLE) = (1<<INT_EN_DAC)|(1<<INT_EN_RX);
  /* Sine test */
  {
    register __i1 s_int16 *wr;
    register s_int16 i, phase = 0;
    s_int16 loops = 24000U/16; /* max 1 second */
    
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN1);
    USEX(SCI_STATUS) &= ~(1<<SCIST_APDOWN2);
    AudioSet(1, 48000U);
    ai.channels = 2;
    skipMixer = 1;

    while (1) {
      pcm_point = 0;
      wr = pcm_sample;
      for (i=0; i<32; i++) {
	*wr++ = cos64NewTab[phase];
	*wr++ = -cos64NewTab[phase];
	phase = (phase + 3) & 127; /* 1125Hz */
      }
      wav_write();

      puthex(loops);
      putch('\n');
      if (--loops <= 0 || USEX(SCI_AICTRL1) != 0) {
	break; /* Done */
      }
    }
  }
  USEX(INT_ENABLE) = (1<<INT_EN_RX);

  //USEX(UART_DIV) = UartDiv();

  /*
    GPIO0 100k to IOVDD (100k to GPIO2)
    GPIO1 100k to GND (SPI CLK, SD XCS)
    GPIO2 100k to GND (100k to GPIO0)
    GPIO3 100k to GND (SD CLK)
  */
 again:

#if 0 /* only without tester and without uSD card */
  if (okmask == (PULL_OK|FLASH_OK|SD_OK)) {
    putstrp("\p**ALL OK!**\n");
    //goto finished;
  }
  while (1) {
    u_int16 failed = 0;
    
    USEX(GPIO_DDR)   = 15; /*outputs*/
    USEX(GPIO_ODATA) = 15; /*drive high*/
    busywait();
    failed |= 0xf ^ USEX(GPIO_IDATA);
    USEX(GPIO_DDR) = 0; /*inputs*/
    //failed |= 0xe ^ USEX(GPIO_IDATA);
    busywait();
    
    failed |= USEX(GPIO_IDATA); /*0*/

    USEX(GPIO_DDR)   = 3; /*outputs*/
    USEX(GPIO_ODATA) = 3; /*drive high*/
    busywait();
    failed |= 7 ^ USEX(GPIO_IDATA); /*7*/
    USEX(GPIO_ODATA) = 0; /*drive low*/
    //failed |= 4 ^ USEX(GPIO_IDATA); /*4*/
    busywait();

    failed |= USEX(GPIO_IDATA); /*0*/
    //puthex(failed);
    if (failed) {
      /*Note: do not flag error! This is produced if uSD is inserted.*/
      putstrp("\p Pull-Up test failed!\n");
    } else {
      putstrp("\p Pull-Ups ok!\n");
      okmask |= PULL_OK;
      break;
    }
  }
#endif

  while (1) {
    putstrp("\p\ntesting SPI FLASH\n");

    USEX(MODU_DIV) = 0;
    USEX(GPIO_DDR)   = SPI_xCS|SPI_CLK|SPI_xCS2;
    USEX(GPIO_ODATA) = SPI_xCS|SPI_CLK|SPI_xCS2;

    /* 'wake up' spi memory */
    SpiSendReceiveSpi(0, 8);
    {
      register u_int16 status;
      USEX(GPIO_ODATA) |= SPI_xCS;
      for (status=0;status<450;status++) {
	//BusyWait10();
	SpiPrivSendReceive(0,16);
      }
      
      USEX(GPIO_ODATA) &= ~SPI_xCS;
      
      /* Use RDID instead, more manufacturers use it like this. */
      {
	u_int16 manuf;
	SpiPrivSendReceive(0x9f,8); /*0x9f=RDID*/
	manuf = SpiPrivSendReceive(0x00,8);
	status = SpiPrivSendReceive(0x00,16);
	USEX(GPIO_ODATA) |= SPI_xCS;

	//putword(status);
	//putch('\n');
	puthex(manuf);
	puthex(status);
	if (status != 0xffff && status != 0) {
	  /*
	    C2=Macronix
	    C8=Spansion
	    manufacturer, memory type, size
	    00c22015 = Macronix SPI FLASH, 2MB
	    00c84015 = Spansion SPI FLASH, 2MB
	  */
	  if (manuf != 0x00c2) {
	    putstrp("\p **ERROR: not Macronix!\n");
	    if (manuf == 0x00c8) {
	      putstrp("\p(Spansion)\n");
	    }
	  } else if ((status & 255) == 0x15) {
	    putstrp("\p 2MB SPI memory found!\n");
	    okmask |= FLASH_OK;
USEX(SCI_AICTRL0) |= 1;/*2MB*/
	  } else if ((status & 255) == 0x18) {
	    putstrp("\p 16MB SPI memory found!\n");
	    okmask |= FLASH_OK;
USEX(SCI_AICTRL0) |= 2;/*16MB*/
	  } else {
	    putstrp("\p **ERROR: Unknown size SPI memory found!\n");
	  }
	  break;
	} else {
	  putstrp("\p **ERROR: No SPI memory found!\n");
	}
      }
    }
  }

#if 0
  if (okmask == (PULL_OK|FLASH_OK|SD_OK)) {
    putstrp("\p**ALL OK!**\n");
  }
#endif

  //  putstrp("\pTesting uSD!\n");
  {
    register s_int16 i, cmd;
  tryagain:
    for (i=0; i<512; i++) {
      SpiSendClocks();
    }
    /* MMC Init, command 0x40 should return 0x01 if all is ok. */
    i = MmcCommand(MMC_GO_IDLE_STATE/*CMD0*/|0x40,0);
    if (i != 1) {
      //	    putstrp("\pGO_IDLE_STATE failed\n");
      goto tryagain;//continue; /* No valid idle response */
    }
    cmd = MMC_SEND_OP_COND|0x40;
    //MmcCommand(MMC_CRC_ON_OFF/*CMD59*/|0x40, 0);
    if (MmcCommand(MMC_SEND_IF_COND/*CMD8*/|0x40, 0x00000122/*2.7-3.6V*/)
	== 1) {
      /* MMC answers: 0x05 SD answers: 0x01 */
      /* Should we read the whole R7 response? */
      //SpiSendReceiveMmc(-1, 32);
      cmd = 0x40|41; /* ACMD41 - SD_SEND_OP_COND */
    }
    /* MMC Wake-up call, set to Not Idle (mmc returns 0x00)*/
    //i = 0; /* i is 1 when entered .. but does not make the code shorter*/
    while (1) {
      register int c;
      if (cmd == (0x40|41)) {
	MmcCommand(0x40|55/*CMD55*/,0);
	c = MmcCommand(cmd/*MMC_SEND_OP_COND|0x40*/, 0x40000000UL);
      } else {
	c = MmcCommand(cmd/*MMC_SEND_OP_COND|0x40*/, 0);
      }
      if (c == 0) {
	break;
      }
      if (++i >= 32000/*12000*//*< 0*/ || c != 1) {
	putstrp("\p**SEND_OP_COND failed\n");
	goto tryagain; /* Not able to power up mmc */
      }
    }
    
    /* PRETEC's 1G MMC does not seemd to handle CMD58 here! */
    /* Support HC for SD, but not for MMC! */
    hcShift = 9;
    if (cmd == (0x40|41) &&
	MmcCommand(MMC_READ_OCR/*CMD58*/|0x40, 0) == 0) {
      if (SpiSendReceiveMmc(-1, 16) & (1<<(30-16))) {
	/* OCR[30]:CCS - card capacity select */
	/* HighCapacity! */
	putstrp("\pSDHC OK\n");
	hcShift = 0;
      }
      //SpiSendReceiveMmc(-1, 16);
    }
    WriteToProgramRam((u_int16)ReadDiskSector+2, 0,
		      (hcShift ? 0x0246 : 0x0006));
    
    putstrp("\pSD OK\n");
    okmask |= SD_OK;
    //goto again;
  }
USEX(SCI_AICTRL0) |= 4;/*uSD*/

  if (InitFileSystem() == 0) {
    putstrp("\pFilesystem OK\n");
USEX(SCI_AICTRL0) |= 8;/*filesystem ok*/
 if (OpenFile(-1) < 0) {
      int words = (fatInfo.fileSize+1)/2;
      u_int32 sector = 0;
USEX(SCI_AICTRL0) |= 16;/*opened*/
      putstrp("\pOpened\n");
      while (words >= 0) {
	register __i2 u_int16 *p;
	ReadDiskSector(sector + (fragments[0].start & 0x7fffffffUL));
	USEX(GPIO_ODATA) |= SPI_xCS;
	if ((sector & 7) == 0) {
	  /* Erase 4KB */
	  SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
	  SingleCycleCommand(SPI_EEPROM_COMMAND_CLEAR_ERROR_FLAGS);
	  EeUnprotect();
	  USEX(GPIO_ODATA) &= ~SPI_xCS;
	  SpiSendReceiveSpi(SPI_EEPROM_COMMAND_ERASE_4K_SECTOR<<8,8);
	  SpiSendReceiveSpi((sector<<1),16);
	  SpiSendReceiveSpi(0,8);
	  USEX(GPIO_ODATA) |= SPI_xCS;

	  SpiWaitStatus();
	}
	//SpiWriteBlock();
	EeUnprotect();
	/* Write the first half */
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,8);
	SpiSendReceiveSpi((sector<<1),16);
	SpiSendReceiveSpi(0,8);
	p = stream_buffer;
	{
	  u_int16 n;
	  for (n=0; n<256/2; n++) {
	    SpiSendReceiveSpi(*p++,16);
	  }
	}
	USEX(GPIO_ODATA) |= SPI_xCS;
	SpiWaitStatus();

	/* Write the second half */
	SingleCycleCommand(SPI_EEPROM_COMMAND_WRITE_ENABLE);
	USEX(GPIO_ODATA) &= ~SPI_xCS;
	SpiSendReceiveSpi(SPI_EEPROM_COMMAND_WRITE<<8,8);
	SpiSendReceiveSpi((sector<<1)|1,16);
	SpiSendReceiveSpi(0,8);
	{
	  u_int16 n;
	  for (n=0; n<256/2; n++) {
	    SpiSendReceiveSpi(*p++,16);
	  }
	}
	USEX(GPIO_ODATA) |= SPI_xCS;
	SpiWaitStatus();

	sector++;
	words -= 256;
       }
      USEX(SCI_AICTRL0) |= 32;/*finished*/
 putstrp("\pFinished!\n");
    } else {
      putstrp("\pNot Opened\n");
    }
  }
  while (1)
    ;
}
